﻿Type=Service
Version=1.70
StartAtBoot=False
@EndOfDesignText@
'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim rv As RemoteViews
	Dim news As String
	Dim ix As Int
	Dim MainURL As String
End Sub

Sub Service_Create
	' Configure the homescreen widget. We let it update every 2 hours here. This is
	' normally not necessary but I want to be sure that the clock restarts if there
	' is any problem.
	rv = ConfigureHomeWidget("widget_layout", "rv", 30, "ANews")

	HttpUtils.CallbackActivity = "Main"
  HttpUtils.CallbackJobDoneSub = "JobDone"
  MainUrl = "http://news.google.com.hk/news?edchanged=1&ned=us"

  HttpUtils.Download("Main page", MainUrl)

	ix = 1
End Sub

Sub Service_Start (StartingIntent As Intent)
	' If a widget is removed from homescreen we don't need to do anything
	If StartingIntent.Action = "android.appwidget.action.APPWIDGET_DELETED" Then Return
	
	' Handle the widget events (RequestUpdate and Disabled)
	If rv.HandleWidgetEvents(StartingIntent) = False Then
		' If the action is not handled by HandleWidgetEvents() then we
		' probably were called by StartService() or StartServiceAt().
		' So just update the widget.
		rv_RequestUpdate
	End If
	
	' We have to be sure that we do not start the service
	' again if all widgets are removed from homescreen
	If StartingIntent.Action <> "android.appwidget.action.APPWIDGET_DISABLED" Then
		StartServiceAt("", TimeToNextMinute, False)
	End If
End Sub

Sub rv_RequestUpdate
	' Just update the time on the widget
	DateTime.TimeFormat = "HH:mm"
	
	rv.UpdateWidget
	ix = ix + 1
	Load_News
End Sub

Sub rv_Disabled
	' If all widgets are removed from homescreen cancel the next schedule and
	' stop the service
	CancelScheduledService("")
	StopService("")
End Sub

Sub Service_Destroy

End Sub

Sub TimeToNextMinute As Long
	Dim ret As Long

	ret = DateTime.Now + (DateTime.TicksPerMinute/6)
	ret = ret - (ret Mod (DateTime.TicksPerMinute/6))	
	Return ret
End Sub

Sub JobDone(Job As String)
  Select job
    Case "Main page"
      Load_News
  End Select
End Sub

Sub Load_News
  Dim TextReader1 As TextReader
  TextReader1.Initialize2(HttpUtils.GetInputStream(MainUrl),"utf8")
  line = TextReader1.ReadAll

  TextReader1.Close
  rv.SetText("Label1", ix & "-" & line)
End Sub
